#line 1 "C:/Users/Andrew/Desktop/Building an HDR Panoramic Camera Rig/code/UpDown_Code/mikroC PRO for PIC32/UpDown_driver.c"
#line 1 "c:/users/andrew/desktop/building an hdr panoramic camera rig/code/updown_code/mikroc pro for pic32/updown_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct Button_Round {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton_Round;

typedef struct CircleButton {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircleButton;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int Buttons_RoundCount;
 TButton_Round * const code *Buttons_Round;
 unsigned int CircleButtonsCount;
 TCircleButton * const code *CircleButtons;
};

extern TScreen Screen1;
extern TButton_Round ShutterFasterButton;
extern TButton_Round ShutterSlowerButton;
extern TButton_Round StopPlusButtonRound;
extern TButton_Round StopMinusButtonRound;
extern TButton_Round FullResetbutton;
extern TCircleButton ShutterButton;
extern TButton_Round * const code Screen1_Buttons_Round[5];
extern TCircleButton * const code Screen1_CircleButtons[1];




void FullResetbuttonOnClick();
void ShutterButtonOnClick();
void ShutterFasterButtonOnPress();
void ShutterSlowerButtonOnPress();
void StopMinusButtonRoundOnClick();
void StopPlusButtonRoundOnClick();




extern char ShutterFasterButton_Caption[];
extern char ShutterSlowerButton_Caption[];
extern char StopPlusButtonRound_Caption[];
extern char StopMinusButtonRound_Caption[];
extern char FullResetbutton_Caption[];
extern char ShutterButton_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawRoundButton(TButton_Round *Around_button);
void DrawCircleButton(TCircleButton *ACircle_button);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "c:/users/andrew/desktop/building an hdr panoramic camera rig/code/updown_code/mikroc pro for pic32/updown_resources.h"
const code char Tahoma26x33_Regular[];
const code char Tahoma29x36_Regular[];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic32/include/built_in.h"
#line 7 "C:/Users/Andrew/Desktop/Building an HDR Panoramic Camera Rig/code/UpDown_Code/mikroC PRO for PIC32/UpDown_driver.c"
char TFT_DataPort at LATE;
sbit TFT_RST at LATC1_bit;
sbit TFT_BLED at LATA9_bit;
sbit TFT_RS at LATB15_bit;
sbit TFT_CS at LATF12_bit;
sbit TFT_RD at LATD5_bit;
sbit TFT_WR at LATD4_bit;
char TFT_DataPort_Direction at TRISE;
sbit TFT_RST_Direction at TRISC1_bit;
sbit TFT_BLED_Direction at TRISA9_bit;
sbit TFT_RS_Direction at TRISB15_bit;
sbit TFT_CS_Direction at TRISF12_bit;
sbit TFT_RD_Direction at TRISD5_bit;
sbit TFT_WR_Direction at TRISD4_bit;



sbit DriveX_Left at LATB13_bit;
sbit DriveX_Right at LATB11_bit;
sbit DriveY_Up at LATB12_bit;
sbit DriveY_Down at LATB10_bit;
sbit DriveX_Left_Direction at TRISB13_bit;
sbit DriveX_Right_Direction at TRISB11_bit;
sbit DriveY_Up_Direction at TRISB12_bit;
sbit DriveY_Down_Direction at TRISB10_bit;



unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 1000;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton_Round *local_round_button;
TButton_Round *exec_round_button;
int round_button_order;
TCircleButton *local_circle_button;
TCircleButton *exec_circle_button;
int circle_button_order;


void PMPWaitBusy() {
 while(PMMODEbits.BUSY);
}

void Set_Index(unsigned short index) {
 TFT_RS = 0;
 PMDIN = index;
 PMPWaitBusy();
}

void Write_Command( unsigned short cmd ) {
 TFT_RS = 1;
 PMDIN = cmd;
 PMPWaitBusy();
}

void Write_Data(unsigned int _data) {
 TFT_RS = 1;
 PMDIN = _data;
 PMPWaitBusy();
}


void Init_ADC() {
 AD1PCFG = 0xFFFF;
 PCFG12_bit = 0;
 PCFG13_bit = 0;

 ADC1_Init();
}
static void InitializeTouchPanel() {
 Init_ADC();
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init(320, 240);

 TP_TFT_Init(320, 240, 13, 12);
 TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);

 PenDown = 0;
 PressedObject = 0;
 PressedObjectType = -1;
}



 TScreen* CurrentScreen;

 TScreen Screen1;
 TButton_Round ShutterFasterButton;
char ShutterFasterButton_Caption[8] = "Dial Up";

 TButton_Round ShutterSlowerButton;
char ShutterSlowerButton_Caption[10] = "Dial Down";

 TButton_Round StopPlusButtonRound;
char StopPlusButtonRound_Caption[6] = "Stop+";

 TButton_Round StopMinusButtonRound;
char StopMinusButtonRound_Caption[6] = "Stop-";

 TButton_Round FullResetbutton;
char FullResetbutton_Caption[11] = "Full Reset";

 TCircleButton ShutterButton;
char ShutterButton_Caption[8] = "Shutter";

 TButton_Round * const code Screen1_Buttons_Round[5]=
 {
 &ShutterFasterButton,
 &ShutterSlowerButton,
 &StopPlusButtonRound,
 &StopMinusButtonRound,
 &FullResetbutton
 };
 TCircleButton * const code Screen1_CircleButtons[1]=
 {
 &ShutterButton
 };



static void InitializeObjects() {
 Screen1.Color = 0x4228;
 Screen1.Width = 320;
 Screen1.Height = 240;
 Screen1.Buttons_RoundCount = 5;
 Screen1.Buttons_Round = Screen1_Buttons_Round;
 Screen1.CircleButtonsCount = 1;
 Screen1.CircleButtons = Screen1_CircleButtons;
 Screen1.ObjectsCount = 6;


 ShutterFasterButton.OwnerScreen = &Screen1;
 ShutterFasterButton.Order = 0;
 ShutterFasterButton.Left = 0;
 ShutterFasterButton.Top = 0;
 ShutterFasterButton.Width = 160;
 ShutterFasterButton.Height = 65;
 ShutterFasterButton.Pen_Width = 1;
 ShutterFasterButton.Pen_Color = 0x0000;
 ShutterFasterButton.Visible = 1;
 ShutterFasterButton.Active = 1;
 ShutterFasterButton.Transparent = 1;
 ShutterFasterButton.Caption = ShutterFasterButton_Caption;
 ShutterFasterButton.TextAlign = _taCenter;
 ShutterFasterButton.FontName = Tahoma29x36_Regular;
 ShutterFasterButton.PressColEnabled = 1;
 ShutterFasterButton.Font_Color = 0x0000;
 ShutterFasterButton.Gradient = 1;
 ShutterFasterButton.Gradient_Orientation = 0;
 ShutterFasterButton.Gradient_Start_Color = 0xFFFF;
 ShutterFasterButton.Gradient_End_Color = 0xC618;
 ShutterFasterButton.Color = 0xC618;
 ShutterFasterButton.Press_Color = 0xE71C;
 ShutterFasterButton.Corner_Radius = 3;
 ShutterFasterButton.OnUpPtr = 0;
 ShutterFasterButton.OnDownPtr = 0;
 ShutterFasterButton.OnClickPtr = 0;
 ShutterFasterButton.OnPressPtr = ShutterFasterButtonOnPress;

 ShutterSlowerButton.OwnerScreen = &Screen1;
 ShutterSlowerButton.Order = 1;
 ShutterSlowerButton.Left = 0;
 ShutterSlowerButton.Top = 65;
 ShutterSlowerButton.Width = 160;
 ShutterSlowerButton.Height = 66;
 ShutterSlowerButton.Pen_Width = 1;
 ShutterSlowerButton.Pen_Color = 0x0000;
 ShutterSlowerButton.Visible = 1;
 ShutterSlowerButton.Active = 1;
 ShutterSlowerButton.Transparent = 1;
 ShutterSlowerButton.Caption = ShutterSlowerButton_Caption;
 ShutterSlowerButton.TextAlign = _taCenter;
 ShutterSlowerButton.FontName = Tahoma29x36_Regular;
 ShutterSlowerButton.PressColEnabled = 1;
 ShutterSlowerButton.Font_Color = 0x0000;
 ShutterSlowerButton.Gradient = 1;
 ShutterSlowerButton.Gradient_Orientation = 0;
 ShutterSlowerButton.Gradient_Start_Color = 0xFFFF;
 ShutterSlowerButton.Gradient_End_Color = 0xC618;
 ShutterSlowerButton.Color = 0xC618;
 ShutterSlowerButton.Press_Color = 0xE71C;
 ShutterSlowerButton.Corner_Radius = 3;
 ShutterSlowerButton.OnUpPtr = 0;
 ShutterSlowerButton.OnDownPtr = 0;
 ShutterSlowerButton.OnClickPtr = 0;
 ShutterSlowerButton.OnPressPtr = ShutterSlowerButtonOnPress;

 StopPlusButtonRound.OwnerScreen = &Screen1;
 StopPlusButtonRound.Order = 2;
 StopPlusButtonRound.Left = 192;
 StopPlusButtonRound.Top = 0;
 StopPlusButtonRound.Width = 128;
 StopPlusButtonRound.Height = 65;
 StopPlusButtonRound.Pen_Width = 1;
 StopPlusButtonRound.Pen_Color = 0x0000;
 StopPlusButtonRound.Visible = 1;
 StopPlusButtonRound.Active = 1;
 StopPlusButtonRound.Transparent = 1;
 StopPlusButtonRound.Caption = StopPlusButtonRound_Caption;
 StopPlusButtonRound.TextAlign = _taCenter;
 StopPlusButtonRound.FontName = Tahoma29x36_Regular;
 StopPlusButtonRound.PressColEnabled = 1;
 StopPlusButtonRound.Font_Color = 0x0000;
 StopPlusButtonRound.Gradient = 1;
 StopPlusButtonRound.Gradient_Orientation = 0;
 StopPlusButtonRound.Gradient_Start_Color = 0xFFFF;
 StopPlusButtonRound.Gradient_End_Color = 0xC618;
 StopPlusButtonRound.Color = 0xC618;
 StopPlusButtonRound.Press_Color = 0xE71C;
 StopPlusButtonRound.Corner_Radius = 3;
 StopPlusButtonRound.OnUpPtr = 0;
 StopPlusButtonRound.OnDownPtr = 0;
 StopPlusButtonRound.OnClickPtr = StopPlusButtonRoundOnClick;
 StopPlusButtonRound.OnPressPtr = 0;

 StopMinusButtonRound.OwnerScreen = &Screen1;
 StopMinusButtonRound.Order = 3;
 StopMinusButtonRound.Left = 192;
 StopMinusButtonRound.Top = 65;
 StopMinusButtonRound.Width = 128;
 StopMinusButtonRound.Height = 65;
 StopMinusButtonRound.Pen_Width = 1;
 StopMinusButtonRound.Pen_Color = 0x0000;
 StopMinusButtonRound.Visible = 1;
 StopMinusButtonRound.Active = 1;
 StopMinusButtonRound.Transparent = 1;
 StopMinusButtonRound.Caption = StopMinusButtonRound_Caption;
 StopMinusButtonRound.TextAlign = _taCenter;
 StopMinusButtonRound.FontName = Tahoma29x36_Regular;
 StopMinusButtonRound.PressColEnabled = 1;
 StopMinusButtonRound.Font_Color = 0x0000;
 StopMinusButtonRound.Gradient = 1;
 StopMinusButtonRound.Gradient_Orientation = 0;
 StopMinusButtonRound.Gradient_Start_Color = 0xFFFF;
 StopMinusButtonRound.Gradient_End_Color = 0xC618;
 StopMinusButtonRound.Color = 0xC618;
 StopMinusButtonRound.Press_Color = 0xE71C;
 StopMinusButtonRound.Corner_Radius = 3;
 StopMinusButtonRound.OnUpPtr = 0;
 StopMinusButtonRound.OnDownPtr = 0;
 StopMinusButtonRound.OnClickPtr = StopMinusButtonRoundOnClick;
 StopMinusButtonRound.OnPressPtr = 0;

 FullResetbutton.OwnerScreen = &Screen1;
 FullResetbutton.Order = 4;
 FullResetbutton.Left = 1;
 FullResetbutton.Top = 159;
 FullResetbutton.Width = 160;
 FullResetbutton.Height = 65;
 FullResetbutton.Pen_Width = 1;
 FullResetbutton.Pen_Color = 0x0000;
 FullResetbutton.Visible = 1;
 FullResetbutton.Active = 1;
 FullResetbutton.Transparent = 1;
 FullResetbutton.Caption = FullResetbutton_Caption;
 FullResetbutton.TextAlign = _taCenter;
 FullResetbutton.FontName = Tahoma29x36_Regular;
 FullResetbutton.PressColEnabled = 1;
 FullResetbutton.Font_Color = 0x0000;
 FullResetbutton.Gradient = 1;
 FullResetbutton.Gradient_Orientation = 0;
 FullResetbutton.Gradient_Start_Color = 0xFFFF;
 FullResetbutton.Gradient_End_Color = 0xC618;
 FullResetbutton.Color = 0xC618;
 FullResetbutton.Press_Color = 0xE71C;
 FullResetbutton.Corner_Radius = 3;
 FullResetbutton.OnUpPtr = 0;
 FullResetbutton.OnDownPtr = 0;
 FullResetbutton.OnClickPtr = FullResetbuttonOnClick;
 FullResetbutton.OnPressPtr = 0;

 ShutterButton.OwnerScreen = &Screen1;
 ShutterButton.Order = 5;
 ShutterButton.Left = 204;
 ShutterButton.Top = 133;
 ShutterButton.Radius = 52;
 ShutterButton.Pen_Width = 4;
 ShutterButton.Pen_Color = 0x0000;
 ShutterButton.Visible = 1;
 ShutterButton.Active = 1;
 ShutterButton.Transparent = 1;
 ShutterButton.Caption = ShutterButton_Caption;
 ShutterButton.TextAlign = _taCenter;
 ShutterButton.FontName = Tahoma26x33_Regular;
 ShutterButton.PressColEnabled = 1;
 ShutterButton.Font_Color = 0x0000;
 ShutterButton.Gradient = 1;
 ShutterButton.Gradient_Orientation = 0;
 ShutterButton.Gradient_Start_Color = 0xF800;
 ShutterButton.Gradient_End_Color = 0x8000;
 ShutterButton.Color = 0xC618;
 ShutterButton.Press_Color = 0xE71C;
 ShutterButton.OnUpPtr = 0;
 ShutterButton.OnDownPtr = 0;
 ShutterButton.OnClickPtr = ShutterButtonOnClick;
 ShutterButton.OnPressPtr = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) {
 if ( (Left<= X) && (Left+ Width - 1 >= X) &&
 (Top <= Y) && (Top + Height - 1 >= Y) )
 return 1;
 else
 return 0;
}






void DrawRoundButton(TButton_Round *Around_button) {
 if (Around_button->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(Around_button->Transparent, Around_button->Press_Color, Around_button->Gradient, Around_button->Gradient_Orientation,
 Around_button->Gradient_End_Color, Around_button->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(Around_button->Transparent, Around_button->Color, Around_button->Gradient, Around_button->Gradient_Orientation,
 Around_button->Gradient_Start_Color, Around_button->Gradient_End_Color);
 }
 TFT_Set_Pen(Around_button->Pen_Color, Around_button->Pen_Width);
 TFT_Rectangle_Round_Edges(Around_button->Left + 1, Around_button->Top + 1,
 Around_button->Left + Around_button->Width - 2,
 Around_button->Top + Around_button->Height - 2, Around_button->Corner_Radius);
 TFT_Set_Font(Around_button->FontName, Around_button->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text_Return_Pos(Around_button->Caption, Around_button->Left, Around_button->Top);
 if (Around_button->TextAlign == _taLeft)
 TFT_Write_Text(Around_button->Caption, Around_button->Left + 4, (Around_button->Top + ((Around_button->Height - caption_height) / 2)));
 else if (Around_button->TextAlign == _taCenter)
 TFT_Write_Text(Around_button->Caption, (Around_button->Left + (Around_button->Width - caption_length) / 2), (Around_button->Top + ((Around_button->Height - caption_height) / 2)));
 else if (Around_button->TextAlign == _taRight)
 TFT_Write_Text(Around_button->Caption, Around_button->Left + (Around_button->Width - caption_length - 4), (Around_button->Top + (Around_button->Height - caption_height) / 2));
 }
}

void DrawCircleButton(TCircleButton *ACircle_button) {
 if (ACircle_button->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(ACircle_button->Transparent, ACircle_button->Press_Color, ACircle_button->Gradient, ACircle_button->Gradient_Orientation,
 ACircle_button->Gradient_End_Color, ACircle_button->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(ACircle_button->Transparent, ACircle_button->Color, ACircle_button->Gradient, ACircle_button->Gradient_Orientation,
 ACircle_button->Gradient_Start_Color, ACircle_button->Gradient_End_Color);
 }
 TFT_Set_Pen(ACircle_button->Pen_Color, ACircle_button->Pen_Width);
 TFT_Circle(ACircle_button->Left + ACircle_button->Radius,
 ACircle_button->Top + ACircle_button->Radius,
 ACircle_button->Radius);
 TFT_Set_Font(ACircle_button->FontName, ACircle_button->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text_Return_Pos(ACircle_button->Caption, ACircle_button->Left, ACircle_button->Top);
 if (ACircle_button->TextAlign == _taLeft)
 TFT_Write_Text(ACircle_button->Caption, ACircle_button->Left + 4, (ACircle_button->Top + ACircle_button->Radius - caption_height / 2));
 else if (ACircle_button->TextAlign == _taCenter)
 TFT_Write_Text(ACircle_button->Caption, (ACircle_button->Left + (ACircle_button->Radius*2 - caption_length) / 2), (ACircle_button->Top + ACircle_button->Radius - caption_height / 2));
 else if (ACircle_button->TextAlign == _taRight)
 TFT_Write_Text(ACircle_button->Caption, ACircle_button->Left + (ACircle_button->Radius*2 - caption_length - 4), (ACircle_button->Top + ACircle_button->Radius - caption_height / 2));
 }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
 unsigned short round_button_idx;
 TButton_Round *local_round_button;
 unsigned short circle_button_idx;
 TCircleButton *local_circle_button;
 char save_bled, save_bled_direction;

 object_pressed = 0;
 order = 0;
 round_button_idx = 0;
 circle_button_idx = 0;
 CurrentScreen = aScreen;

 if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
 save_bled = TFT_BLED;
 save_bled_direction = TFT_BLED_Direction;
 TFT_BLED_Direction = 0;
 TFT_BLED = 0;
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init(CurrentScreen->Width, CurrentScreen->Height);
 TP_TFT_Init(CurrentScreen->Width, CurrentScreen->Height, 13, 12);
 TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);
 TFT_Fill_Screen(CurrentScreen->Color);
 display_width = CurrentScreen->Width;
 display_height = CurrentScreen->Height;
 TFT_BLED = save_bled;
 TFT_BLED_Direction = save_bled_direction;
 }
 else
 TFT_Fill_Screen(CurrentScreen->Color);


 while (order < CurrentScreen->ObjectsCount) {
 if (round_button_idx < CurrentScreen->Buttons_RoundCount) {
 local_round_button =  CurrentScreen->Buttons_Round[round_button_idx] ;
 if (order == local_round_button->Order) {
 round_button_idx++;
 order++;
 DrawRoundButton(local_round_button);
 }
 }

 if (circle_button_idx < CurrentScreen->CircleButtonsCount) {
 local_circle_button =  CurrentScreen->CircleButtons[circle_button_idx] ;
 if (order == local_circle_button->Order) {
 circle_button_idx++;
 order++;
 DrawCircleButton(local_circle_button);
 }
 }

 }
}

void Get_Object(unsigned int X, unsigned int Y) {
 round_button_order = -1;
 circle_button_order = -1;

 for ( _object_count = 0 ; _object_count < CurrentScreen->Buttons_RoundCount ; _object_count++ ) {
 local_round_button =  CurrentScreen->Buttons_Round[_object_count] ;
 if (local_round_button->Active == 1) {
 if (IsInsideObject(X, Y, local_round_button->Left, local_round_button->Top,
 local_round_button->Width, local_round_button->Height) == 1) {
 round_button_order = local_round_button->Order;
 exec_round_button = local_round_button;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->CircleButtonsCount ; _object_count++ ) {
 local_circle_button =  CurrentScreen->CircleButtons[_object_count] ;
 if (local_circle_button->Active == 1) {
 if (IsInsideObject(X, Y, local_circle_button->Left, local_circle_button->Top,
 (local_circle_button->Radius * 2), (local_circle_button->Radius * 2)) == 1) {
 circle_button_order = local_circle_button->Order;
 exec_circle_button = local_circle_button;
 }
 }
 }

 _object_count = -1;
 if (round_button_order > _object_count )
 _object_count = round_button_order;
 if (circle_button_order > _object_count )
 _object_count = circle_button_order;
}


void Process_TP_Press(unsigned int X, unsigned int Y) {
 exec_round_button = 0;
 exec_circle_button = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == round_button_order) {
 if (exec_round_button->Active == 1) {
 if (exec_round_button->OnPressPtr != 0) {
 exec_round_button->OnPressPtr();
 return;
 }
 }
 }

 if (_object_count == circle_button_order) {
 if (exec_circle_button->Active == 1) {
 if (exec_circle_button->OnPressPtr != 0) {
 exec_circle_button->OnPressPtr();
 return;
 }
 }
 }

 }
}

void Process_TP_Up(unsigned int X, unsigned int Y) {

 switch (PressedObjectType) {

 case 1: {
 if (PressedObject != 0) {
 exec_round_button = (TButton_Round*)PressedObject;
 if ((exec_round_button->PressColEnabled == 1) && (exec_round_button->OwnerScreen == CurrentScreen)) {
 DrawRoundButton(exec_round_button);
 }
 break;
 }
 break;
 }

 case 5: {
 if (PressedObject != 0) {
 exec_circle_button = (TCircleButton*)PressedObject;
 if ((exec_circle_button->PressColEnabled == 1) && (exec_circle_button->OwnerScreen == CurrentScreen)) {
 DrawCircleButton(exec_circle_button);
 }
 break;
 }
 break;
 }
 }


 Get_Object(X, Y);


 if (_object_count != -1) {

 if (_object_count == round_button_order) {
 if (exec_round_button->Active == 1) {
 if (exec_round_button->OnUpPtr != 0)
 exec_round_button->OnUpPtr();
 if (PressedObject == (void *)exec_round_button)
 if (exec_round_button->OnClickPtr != 0)
 exec_round_button->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (_object_count == circle_button_order) {
 if (exec_circle_button->Active == 1) {
 if (exec_circle_button->OnUpPtr != 0)
 exec_circle_button->OnUpPtr();
 if (PressedObject == (void *)exec_circle_button)
 if (exec_circle_button->OnClickPtr != 0)
 exec_circle_button->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }

 }
 PressedObject = 0;
 PressedObjectType = -1;
}

void Process_TP_Down(unsigned int X, unsigned int Y) {

 object_pressed = 0;
 exec_round_button = 0;
 exec_circle_button = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == round_button_order) {
 if (exec_round_button->Active == 1) {
 if (exec_round_button->PressColEnabled == 1) {
 object_pressed = 1;
 DrawRoundButton(exec_round_button);
 }
 PressedObject = (void *)exec_round_button;
 PressedObjectType = 1;
 if (exec_round_button->OnDownPtr != 0) {
 exec_round_button->OnDownPtr();
 return;
 }
 }
 }

 if (_object_count == circle_button_order) {
 if (exec_circle_button->Active == 1) {
 if (exec_circle_button->PressColEnabled == 1) {
 object_pressed = 1;
 DrawCircleButton(exec_circle_button);
 }
 PressedObject = (void *)exec_circle_button;
 PressedObjectType = 5;
 if (exec_circle_button->OnDownPtr != 0) {
 exec_circle_button->OnDownPtr();
 return;
 }
 }
 }

 }
}

void Check_TP() {
 if (TP_TFT_Press_Detect()) {
 if (TP_TFT_Get_Coordinates(&Xcoord, &Ycoord) == 0) {

 Process_TP_Press(Xcoord, Ycoord);
 if (PenDown == 0) {
 PenDown = 1;
 Process_TP_Down(Xcoord, Ycoord);
 }
 }
 }
 else if (PenDown == 1) {
 PenDown = 0;
 Process_TP_Up(Xcoord, Ycoord);
 }
}

void Init_MCU() {
 PMMODE = 0;
 PMAEN = 0;
 PMCON = 0;
 PMMODEbits.MODE = 2;
 PMMODEbits.WAITB = 0;
 PMMODEbits.WAITM = 1;
 PMMODEbits.WAITE = 0;
 PMMODEbits.MODE16 = 1;
 PMCONbits.CSF = 0;
 PMCONbits.PTRDEN = 1;
 PMCONbits.PTWREN = 1;
 PMCONbits.PMPEN = 1;
 TFT_Set_Default_Mode();
 TP_TFT_Set_Default_Mode();
 TFT_Set_Active(Set_Index,Write_Command,Write_Data);
}

void Start_TP() {
 Init_MCU();

 InitializeTouchPanel();


 TP_TFT_Set_Calibration_Consts(76, 907, 77, 915);

 InitializeObjects();
 display_width = Screen1.Width;
 display_height = Screen1.Height;
 DrawScreen(&Screen1);
}
