/*
 * Project name:
     UpDown.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     8/27/2014
 * Time of creation
     4:01:57 PM
 * Test configuration:
     MCU:             P32MX460F512L
     Dev.Board:       MikroMMB_for_PIC32_hw_rev_1.10
                      http://www.mikroe.com/mikromedia/pic32/
     Oscillator:      80000000 Hz
     SW:              mikroC PRO for PIC32
                      http://www.mikroe.com/mikroc/pic32/
 * Software License:
                      GPL v3
                      https://www.gnu.org/licenses/quick-guide-gplv3.html
 * Project by: 
     Andrew Hazelden andrew@andrewhazelden.com
     http://www.andrewhazelden.com/blog
     
 * Notes:
   A Canon DSLR is connected to the Mikromedia board using a modified battery grip.
   
   The Canon DSLR battery grip is modified by soldering 5 jumper wires. The wires
   connect to the rotary dial controls, and the shutter button mechanism. This allows
   the Mikromedia board to externally control the camera.

  If this is your first time modifying a Canon Camera I recommend you start with an 
  affordable used Canon digital SLR camera like the Canon 10D which can be purchased 
  used on eBay for about $100 USD. A battery grip be purchased on eBay for $50 USD. 

  Because this project involves you taking apart the battery grip module, and 
  soldering to a flex ribbon cable, a standard liability disclaimer applies to 
  this DIY project. For my battery grip modification, I routed the jumper wires 
  through the spare battery compartment space and out through a carefully 
  drilled hole in the battery door cover hatch.
   
   The Canon battery grip to Mikromedia PIC32 connections are as follows:
   GND: Green Wire
   RB0: Blue Wire - Dial Up  
   RB1: Purple Wire - Dial Down  
   RB2: Brown Wire - Shutter  
   RB3: Red Wire - Focus  
   
   The source code works by flipping the TRIS state on the pins to send signals 
   to the battery grip module. This means you need to connect the Mikromedia 
   board to the battery grip's jumper wires, power up the Mikromedia board, then 
   finally turn on the Canon DSLR camera. 

  If you turn on the Canon camera before the Mikromedia board the camera will start
  taking photos until the Mikromedia board boots and toggles the TRIS state on the
  PIC32 chip's TRISB port.

 */

#include "UpDown_objects.h"

void main() {

  // [Dial- pin RB0] Mode:Input, Value=0 (Dial Up) Blue Wire
  LATB.F0 = 0;
  TRISB.F0 = 1;

  // [Dial+ pin RB1] Mode:Input, Value=0 (Dial Down) Purple Wire
  LATB.F1 = 0;
  TRISB.F1 = 1;

  // [Shutter pin RB2] Mode:Input, Value=0 (Shutter trigger) Brown Wire
  LATB.F2 = 0;
  TRISB.F2 = 1;

  // [Focus pin RB3] Mode:Input, Value=0 (Focus) Red Wire
  LATB.F3 = 0;
  TRISB.F3 = 1;
  
  Start_TP();

  while (1) {
    Check_TP();
  }
}